		/*//////////   SCRIPT:   AutoLightSelectScript     //////////*/
		/*//////////   WRITTEN BY:   ShyWhy	      //////////*/
		/*//////////   UI + Update after 1.36 BY: Ihno     //////////*/
		
		
		--Version 1.361
		--Added Lightselect modes of VRay 4.0
		
		--Version 1.36-100618
			--Added simple description as "Help" button
			--Added "Separate" option for "All Selection Sets"
			--Added comments to source code
			--Fixed "All in 1"-bug for "All Selection Sets"
			--|where one light was added once too often
		
		--Version 1.35-090618
			--Added "All Selection Sets" option
		
		--Version 1.34-020618
			--Added "In any Selection Set" option
		
		--Version 1.33-010618
			--completely recoded
			--Added "Remove All" button
		
		--Version 1.32-010618
			--Added "Selection Set" option
		
		--Version 1.31-010618
			--Fixed "Only activated lights"-bug for IES , Sun and AmbientLight 
			--|where it didn't work properly for these lights
		
		--Version 1.3-010618
			--Added VRayIES, VRaySun and VRayAmbientLight
		
		--Version 1.2-010618
			--Added "All in 1" Checkbox + functions
		
		--Version 1.1-010618
			--Rewrote script
		
		--Version 1.0-310518
			--Core functions
		



try(closerolloutfloater MainFloater)
catch()

try(closerolloutfloater SubFloater)
catch()




Rollout Menu02 "Selection" width:380 height:310 
(	
		label selection_info_label "-ALL LIGHTS: uses all lights\n\n-CURRENT SELECTION: uses all lights selected\n\n-SELECTION SET: uses all lights in a specific selection set\n\n-DROP DOWN MENU: select a specific selection set\n\n-IN ANY SELECTION SET: uses all lights in any selection set\n  (1 light in 2 selection sets = 1 light)\n\n-ALL SELECTION SETS: uses all lights of all selection sets\n(1 light in 2 selection sets = 2 lights)\n\n" pos:[25, 15] height:200
)

Rollout Menu03 "Options" width:380 height:200 
(	
		label selection_info_label "-ONLY ACTIVATED: limits selection to activated lights\n\n-DUPLICATION ALLOWED: light selects with same name are allowed\n\n-CLEAR ALL LIGHTSELECTS: removes all light selects \nfrom render elements\n\n-CLEAR ELEMENT LIST: removes all render elements before starting\n\n-ALL IN 1: stores all lights in one light select\n\n-INSTANCES IN ONE: lights are grouped with their instances in one\nlight select\n\n -BY SELECTION SET CHECKBOX: groups lights by selection set. \n(Only active when all selection sets is checked)" pos:[25, 15] height:210
)









--MAIN DIALOG
Rollout Menu01 "Auto LightSelect"
(		
	
	groupBox light_Selection "Light Selection" pos:[5,5] width:240 height:105
	--(
		radiobuttons light_sources labels:#("All lights","Current selection", "Selection Set", "In any Selection Set", "All Selection Sets") columns:1  pos:[20,25] 
		dropdownlist selection_sets "" items:#("") width:100 pos:[135,50] enabled:false
	--)	
	
	groupBox light_options "Filter Selection" pos:[5,115] width:240 height:65
	--(
		checkbox only_on "Only activated lights" pos:[20,135] checked:true
		checkbox accept_duplicates "Name duplication allowed" pos:[20,150] checked:false
	--)
	
	groupBox prescript_actions "Pre-Script Actions" pos:[5,185] width:240 height:65
	--(
		checkbox remove_lightSelect "Clear all LightSelects" pos:[20,206] checked:false	
		checkbox clear_list "Clear element list" pos:[20,221] checked:false
	--(
	
	groupBox grouping "Grouping" pos:[5,255] width:240 height:80
	--(
		checkbox as_one "All in one" pos:[20,276] checked:false
		checkbox group_instances "Instances as One" pos:[20,291] checked:true enabled:true
		checkbox pack_sets "By Selection Set" pos:[20,306] checked:false enabled:false
	--)
	groupBox light_modes "Modes" pos:[5,340] width:240 height:115
	--(
		checkbox full "Full" pos:[20,365] checked:true
		checkbox direct_raw "Direct Raw" pos:[20,380] checked:false
		checkbox direct_illumination "Direct Illumination" pos:[20,395] checked:false
		checkbox direct_diffuse "Direct Diffuse" pos:[20,410] checked:false
		checkbox direct_specular "Direct Specular" pos:[20,425] checked:false
		checkbox indirect "Indirect" pos:[130,395] checked:false
		checkbox indirect_diffuse "Indirect Diffuse" pos:[130,410] checked:false
		checkbox indirect_specular "Indirect Specular" pos:[130,425] checked:false
	--)
	groupBox sorting "Sorting" pos:[5,460] width:240 height:50
	--(
		checkbox sort_elements "Sort elements by name" pos:[20,480] checked:true enabled:true
	--)
	button btn_Apply "Start" pos:[75,515] width:80 height:20
	button btn_help "?" pos:[160, 515] width:20 height:20 border:false
	
	--classes allowed for light selects
	local lightClasses = #(VRayLight, VRaySun, VRayIES, VRayAmbientLight)
	
	
	--//summary//
	--Check if light class is ok
	--//summary//
	fn ClassIsAllowed &lightObj = 
	(
		for class in lightClasses do
		(
			if (classof lightObj.baseObject) == class then
			(
				return true
			)
		)
		return false
	)
	
	
	--//summary//
	--Check if light is on
	--//summary//
	fn LightIsOn &lightObj =
	(
			try 
			(
				if lightObj.on then return true
					else return false
			)
			catch
			(
				if lightObj.enabled then return true
					else return false
			)
	)
	
	
	--//summary//
	--Check if light is in 
	--selected  selection set
	--for mode 3
	--//summary//
	fn InCurrentSelectionSet &lightObj =
	(		
		for i = 1 to NamedSelectionSetManager.GetNamedSelSetItemCount (selection_sets.selection-1) do
		(
			if lightObj == NamedSelectionSetManager.GetNamedSelSetItem (selection_sets.selection-1) (i-1) then
			(
					return true
			)
		)
		return false
	)
	
	
	--//summary//
	--Check if light is in 
	--any  selection set
	--for mode 4
	--//summary//
	fn InAnySelectionSet &lightObj =
	(
		for i = 1 to NamedSelectionSetManager.GetNumNamedSelSets() do
		(
			for j = 1 to NamedSelectionSetManager.GetNamedSelSetItemCount (i-1) do
			(
				if lightObj == NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1) then
				(
						return true
				)
			)
		)
		return false
	)
	
	
	--//summary//
	--Adds light after last checks
	--//summary//
	fn AddLight &arrayToSave &lightObj =
	(
		if only_on.checked and LightIsOn lightObj then
		(
			append arrayToSave lightObj
		)
		else if only_on.checked == false then
		(
			append arrayToSave lightObj
		)
	)
	
	
	--//summary//
	--Check if light is first instance
	--in light select
	--//summary//
	fn IsFirstInstance &arrayToSave &lightObj = 
	(
		InstanceMgr.GetInstances lightObj &instances
		
		
		for i = 1 to arrayToSave.count do
		(
			for j = 1 to instances.count do
			(
					if instances[j] == arrayToSave[i]  then
					(
							return false
					)
			)
		)
		return true
	)
	
	
	--//summary//
	--Count how often the light
	--was already saved
	--//summary//
	fn getAmountInLocal &arrayToSave &lightObj = 
	(
		local count = 0
		for x in arrayToSave do
		(
			if x == lightObj then
			(
				count = count + 1
			)
		)
		return count
	)
	
	
	--//summary//
	--Count how often the light
	--exists in all selection sets
	--//summary//
	fn getAmountInSelectionSet &lightObj = 
	(
		local count = 0
		for i = 1 to NamedSelectionSetManager.GetNumNamedSelSets() do
		(
			for j = 1 to NamedSelectionSetManager.GetNamedSelSetItemCount (i-1) do
			(
				if lightObj == (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1)) then
				(
					if only_on.checked and LightIsOn (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1)) then
					(
						count = count + 1
					)
					else if only_on.checked == false then
					(
						count = count + 1
					)
				)
			)
		)		
		return count
	)
	
	
	--//summary//
	--Returns instance of light
	--that was already stored
	--//summary//
	fn GetInstanceAlreadyInLocal &arrayToSave &lightObj =
	(
		InstanceMgr.GetInstances lightObj &instances
		
		for i = 1 to arrayToSave.count do
		(
			for j = 1 to instances.count do
			(
				if instances[j] == arrayToSave[i]  then
				(
					return instances[j]
				)
			)
		)
		return undefined
	)
	
	
	--//summary//
	--Check if the amount of this light in
	--different selection sets is higher than
	--than the amount we saved
	--//summary//
	fn AreThereMore &arrayToSave &lightObj = 
	(		
		local containedInstance = (GetInstanceAlreadyInLocal arrayToSave lightObj)
		
		
		if containedInstance == undefined then
		(
			return true
		)
		else if (getAmountInSelectionSet containedInstance) > (getAmountInLocal arrayToSave containedInstance) and lightObj == containedInstance then
		(	
			return true
		)
		else
		(
			return false
		)
	)
	
	
	--//summary//
	--Check if the current instance is allowed
	--to be stored
	--//summary//
	fn CurrentInstanceAllowed &arrayToSave &lightObj =
	(
		if group_instances.checked and group_instances.enabled and IsFirstInstance arrayToSave lightObj and light_sources.state != 5 then
		(
			return true
		)
		else if group_instances.checked and group_instances.enabled and (AreThereMore arrayToSave lightObj) and light_sources.state == 5 then
		(
			return true
		)
		else if group_instances.checked == false or group_instances.enabled == false then
		(
			return true
		)
		else
		(
			return false
		)
	)
	
	
	--//summary//
	--select individual lights 
	--(as_one is disabled)
	--//summary//
	fn SelectIndividual &arrayToSave &lightObj =
	(
		if light_sources.state == 1 and  CurrentInstanceAllowed arrayToSave lightObj then
		(
			AddLight arrayToSave lightObj
		)
		else if light_sources.state == 2 and lightObj.isSelected and CurrentInstanceAllowed arrayToSave lightObj then
		(
			AddLight arrayToSave lightObj
		)
		else if light_sources.state == 3 and InCurrentSelectionSet lightObj and CurrentInstanceAllowed arrayToSave lightObj then
		(
			AddLight arrayToSave lightObj
		)
		else if light_sources.state == 4 and InAnySelectionSet lightObj and CurrentInstanceAllowed arrayToSave lightObj then
		(
			AddLight arrayToSave lightObj
		)
		else if light_sources.state == 5  and CurrentInstanceAllowed arrayToSave lightObj then
		(
			AddLight arrayToSave lightObj
		)
	)
	
	
	--//summary//
	--Stores just one light
	--(as_one is enabled)
	--//summary//
	fn SelectAsOne &arrayToSave &lightObj =
	(
		if light_sources.state == 1 and arrayToSave.count == 0 then
		(
			AddLight arrayToSave lightObj
		)
		else if light_sources.state == 2 and lightObj.isSelected and arrayToSave.count == 0 then
		(
			AddLight arrayToSave lightObj
		)
		else if light_sources.state == 3 and InCurrentSelectionSet lightObj and arrayToSave.count == 0 then
		(
			AddLight arrayToSave lightObj
		)	
		else if light_sources.state == 4 and InAnySelectionSet lightObj and arrayToSave.count == 0 then
		(
			AddLight arrayToSave lightObj
		)	
		else if light_sources.state == 5 and arrayToSave.count == 0 then
		(
			AddLight arrayToSave lightObj
		)	
	)
	
	
	--//summary//
	--Saves the selection set number
	--//summary//
	fn SelectPackNumber &arrayToSave = 
	(
		for i = 1 to NamedSelectionSetManager.GetNumNamedSelSets() do
		(
			local newSelectionSet = true
			
			for j = 1 to NamedSelectionSetManager.GetNamedSelSetItemCount (i-1) do
			(
				if ClassIsAllowed (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1)) and newSelectionSet then
				(
					AddLight arrayToSave i
					newSelectionSet = false
				)
			)
		)
	)
	
	
	--//summary//
	--Selection for mode 5
	--//summary//
	fn SelectForAllSelectionSets &arrayToSave = 
	(
		if pack_sets.enabled and pack_sets.checked then 
		(
			SelectPackNumber arrayToSave
		)		
		else
		(
			for i = 1 to NamedSelectionSetManager.GetNumNamedSelSets() do
			(
				for j = 1 to NamedSelectionSetManager.GetNamedSelSetItemCount (i-1) do
				(
					if ClassIsAllowed (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1)) then
					(
						if as_one.checked then
						(
							SelectAsOne arrayToSave (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1))
						)
						else
						(
							SelectIndividual arrayToSave (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1))
						)
					)
				)
			)
		)
	)
	
	
	
	
	--//summary//
	--Select the requiered light sources
	--//summary//
	fn SelectLights &arrayToSave = 
	(
		if light_sources.state != 5 then
		(
			for oneOfSelection in lights do
			(
				if ClassIsAllowed oneOfSelection then
				(
					if as_one.checked then
					(
						SelectAsOne arrayToSave oneOfSelection
					)
					else
					(
						SelectIndividual arrayToSave oneOfSelection
					)
				)	
			)
		)
		else
		(
			SelectForAllSelectionSets arrayToSave
		)
	)
	
	
	--//summary//
	--Adds one of the selected lights
	--(as_one is disabled)
	--//summary//
	fn AddSingleOtherLight_ToLightSelect &allLightsForCurrentLightSelect &otherLight =
	(
		if light_sources.state == 1 then
		(
			AddLight allLightsForCurrentLightSelect otherLight
		)
		else if light_sources.state == 2 and otherLight.isSelected then
		(
			AddLight allLightsForCurrentLightSelect otherLight
		)
		else if light_sources.state == 3 and InCurrentSelectionSet otherLight then
		(
			AddLight allLightsForCurrentLightSelect otherLight
		)
		else if light_sources.state == 4 and InAnySelectionSet otherLight then
		(
			AddLight allLightsForCurrentLightSelect otherLight
		)
		else if light_sources.state == 5 and ClassIsAllowed otherLight then
		(
			AddLight allLightsForCurrentLightSelect otherLight
		)
	)
	
	
	--//summary//
	--Check if toTest is instance 
	--of lightObj
	--//summary//
	fn IsInstanceOf &lightObj &toTest = 
	(
		InstanceMgr.GetInstances lightObj &instances
		for instance in instances do
		(
			if instance == toTest then
			(
				return true
			)
		)
		return false
	)
	
	
	--//summary//
	--Adds all instances over all
	--selection sets without
	--selecting itself
	--for mode 5
	--//summary//
	fn AddAllInstances_FromOtherSelectionSets &allLightsForCurrentLightSelect &currentLightSelect = 
	(
		local gotSourceOnce = false
		
		for i = 1 to NamedSelectionSetManager.GetNumNamedSelSets() do
		(
			for j = 1 to NamedSelectionSetManager.GetNamedSelSetItemCount (i-1) do
			(
				if ClassIsAllowed (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1)) then
				(
					InstanceMgr.GetInstances currentLightSelect &instances
					for instance in instances do
					(
						if instance == (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1)) then
						(
							if instance == currentLightSelect then
							(
								if gotSourceOnce == false then
								(
									gotSourceOnce = true
								)
								else
								(
									AddSingleOtherLight_ToLightSelect allLightsForCurrentLightSelect (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1))
								)
							)
							else
							(
								AddSingleOtherLight_ToLightSelect allLightsForCurrentLightSelect (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1))
							)
						)
					)
				)
			)
		)
	)
	
	
	--//summary//
	--Adds all instances over all
	--selection sets without
	--selecting itself
	--for mode 1-4
	--//summary//
	fn AddAllInstances_OfLightSelect &allLightsForCurrentLightSelect &currentLightSelect =
	(
		if light_sources.state != 5 then
		(
			InstanceMgr.GetInstances currentLightSelect &instances
			for instance in instances do
			(
				if currentLightSelect != instance then
				(
					AddSingleOtherLight_ToLightSelect allLightsForCurrentLightSelect instance
				)
			)
		)
		else
		(
			AddAllInstances_FromOtherSelectionSets allLightsForCurrentLightSelect currentLightSelect
		)			
	)
	
	
	--//summary//
	--Adds all other lights to
	--light select
	--(as_one is enabled)
	--//summary//
	fn AddOtherLights_ToLightSelect &allLightsForCurrentLightSelect &currentLightSelect  =
	(
		if light_sources.state != 5 then
		(
			for otherLight in lights do
			(
				if otherLight!= currentLightSelect and ClassIsAllowed otherLight then
				(
					AddSingleOtherLight_ToLightSelect allLightsForCurrentLightSelect otherLight
				)	
			)
		)
		
		--mode 5 extra because we cant iterate over lights
		--maybe one light is in two different selection sets 
		--so we have to iterate over the selection sets
		else
		(
			--helper to not save itself
			local gotSourceOnce = false
			
			for i = 1 to NamedSelectionSetManager.GetNumNamedSelSets() do
			(
				for j = 1 to NamedSelectionSetManager.GetNamedSelSetItemCount (i-1) do
				(
					if currentLightSelect == (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1)) and gotSourceOnce == false then
					(
						gotSourceOnce = true
					)
					else
					(
						AddSingleOtherLight_ToLightSelect allLightsForCurrentLightSelect (NamedSelectionSetManager.GetNamedSelSetItem (i-1) (j-1))
					)
				)
			)
		)
	)
	
	
	--//summary//
	--Adds all lights in the same 
	--selection set for mode 5
	--//summary//
	fn AddToPack &allLightsForCurrentLightSelect &SelectionSetNumber =		
	(
		for i = 1 to NamedSelectionSetManager.GetNamedSelSetItemCount (SelectionSetNumber-1) do
		(
			if ClassIsAllowed (NamedSelectionSetManager.GetNamedSelSetItem (SelectionSetNumber-1) (i-1)) then
			(
				AddSingleOtherLight_ToLightSelect allLightsForCurrentLightSelect (NamedSelectionSetManager.GetNamedSelSetItem (SelectionSetNumber-1) (i-1))
			)
		)
	)
	
	
	--//summary//
	--Checks for different options and
	--adds itself at the end
	--What mode is active and
	--which lights do we have to add?
	--//summary//
	fn AddLightsToLightSelect &currentLightSelect &allLightsForCurrentLightSelect =
	(
		if as_one.checked and as_one.enabled then
		(
			AddOtherLights_ToLightSelect allLightsForCurrentLightSelect currentLightSelect 
		)
		else if group_instances.checked and group_instances.enabled then
		(
			AddAllInstances_OfLightSelect allLightsForCurrentLightSelect currentLightSelect
		)
		else if pack_sets.checked and pack_sets.enabled then
		(
			AddToPack allLightsForCurrentLightSelect currentLightSelect
		)
		if pack_sets.checked == false or pack_sets.enabled == false then
		(
			append allLightsForCurrentLightSelect currentLightSelect
		)
	)
	
	
	--//summary//
	--Creates the name for the VRay Light Select
	--//summary//
	fn GetNameForLightSelect &currentLightSelect =
	(
		local lightSelectName 
		
		if pack_sets.checked == false or pack_sets.enabled == false then
		(
			lightSelectName = currentLightSelect.name
		)
		
		if light_sources.state == 1 and as_one.checked then
		(
			lightSelectName = "Lights"
		)
		else if light_sources.state == 2 and as_one.checked then
		(
			lightSelectName = "Selected_Lights"
		)
		else if light_sources.state == 3 and as_one.checked then
		(
			lightSelectName = NamedSelectionSetManager.GetNamedSelSetName (selection_sets.selection-1)
		)
		else if light_sources.state == 4 and as_one.checked then
		(
			lightSelectName = "LightsInAnySelectionSet"
		)
		else if light_sources.state == 5 and as_one.checked  and as_one.enabled then
		(
			lightSelectName = "AllSelectionSetLights"
		)
		else if light_sources.state == 5 and pack_sets.checked  and pack_sets.enabled then
		(
			lightSelectName = NamedSelectionSetManager.GetNamedSelSetName (currentLightSelect-1)
		)
		--else if group_instances.enabled == true and group_instances.checked == true then
		--(
			--lightSelectName = lightSelectName + "_Instances"
		--)
		return lightSelectName
	)
	
	
	--//summary//
	--Check if the light select with the same name
	--already exists
	--//summary//
	fn LightSelectDoesAlreadyExitst &re &name =
	(			
		for i = 1 to re.NumRenderElements() do
		(
			if (classof (re.GetRenderElement (re.NumRenderElements() - i))) == VRayLightSelect and (re.GetRenderElement (re.NumRenderElements() - i)).elementName == name then
			(
				return true			
			)
		)
		return false
	)
	
	
	--//summary//
	--Last method to create light select
	--//summary//
	fn CreateLightSelect &re &allLightsForCurrentLightSelect &name &mode =
	(
		--check if creation is allowed
		if (LightSelectDoesAlreadyExitst re name) == false or (accept_duplicates.checked and accept_duplicates.enabled) or light_sources.state == 5 then 
		(
			render_Element = VRayLightSelect()
			render_Element.lights = allLightsForCurrentLightSelect
			render_Element.mode = mode		
			render_Element.elementName = name
		
			re.AddRenderElement(render_Element)
		)
	)
	
	
	--//summary//
	--Chooses between the activated modes
	--//summary//
	fn CreateLightSelectModes &re & allLightsForCurrentLightSelect &name = 
	(
		if direct_illumination.checked then
		(
			CreateLightSelect re allLightsForCurrentLightSelect (name + "_Direct_Illumination") 0
		)
		if direct_raw.checked then
		(
			CreateLightSelect re allLightsForCurrentLightSelect  (name + "_Direct_Raw") 1
		)
		if direct_diffuse.checked then
		(
			CreateLightSelect re allLightsForCurrentLightSelect  (name + "_Direct_Diffuse") 2
		)
		if direct_specular.checked then
		(
			CreateLightSelect re allLightsForCurrentLightSelect  (name + "_Direct_Specular") 3
		)
		if full.checked then
		(	
			CreateLightSelect re allLightsForCurrentLightSelect  (name + "_Full") 4
		)
		if indirect.checked then
		(	
			CreateLightSelect re allLightsForCurrentLightSelect  (name + "_Indirect") 5
		)
		if indirect_diffuse.checked then
		(	
			CreateLightSelect re allLightsForCurrentLightSelect  (name + "_Indirect_Diffuse") 6
		)
		if indirect_specular.checked then
		(	
			CreateLightSelect re allLightsForCurrentLightSelect  (name + "_Indirect_Specular") 7
		)
		
		--nothing selected
		if direct_illumination.checked == false and direct_raw == false and direct_diffuse == false and direct_specular == false and full.checked == false then
		(
				messageBox "No mode for VRayLightSelect selected!"
		)
	)
	
	
	--//summary//
	--Sub main for creating the light select
	--(first one has been stored now we have to
	--find the rest of the lights needed)
	--//summary//
	fn GenerateLightSelects &re &allLightSelects =
	(
		for currentLightSelect in allLightSelects do
		(
			local allLightsForCurrentLightSelect = #()
		
			--get the lights for the light select
			AddLightsToLightSelect currentLightSelect allLightsForCurrentLightSelect
			
			
			local name
			
			--get the name
			name = GetNameForLightSelect currentLightSelect
			
			--create it
			CreateLightSelectModes re allLightsForCurrentLightSelect name
		)
	)
	
	--//summary//
	--Removes all light selects of your
	--render elements
	--//summary//
	fn removeAllLightSelects &re =
	(
		local elementsCount = re.NumRenderElements()
		
		for i = 1 to elementsCount do
		(
			if classof (re.GetRenderElement (elementsCount - i)) == VRayLightSelect then
			(
				re.RemoveRenderElement (re.GetRenderElement (elementsCount - i))
			)
		)
	)
	
	--//summary//
	--Counts light selects in render elements
	--//summary//
	fn GetNumberOfLightSelects &re = 
	(
		local count = 0
		
		for i = 1 to re.NumRenderElements() do
		(
			if (classof (re.GetRenderElement(i - 1))) == VRayLightSelect then
			(
				count = count + 1
			)
		)
		return count
	)
	
	
	--//summary//
	--Removes all light selects of your
	--render elements
	--//summary//
	fn RemoveLowestLightSelect &re = 
	(
		local render_element
		local sortName = "zzz"
		local light_select
		
		for i = 1 to re.NumRenderElements() do
		(
			if (classof (re.GetRenderElement (re.NumRenderElements() - i))) == VRayLightSelect then
			(
				if (re.GetRenderElement (i-1)).elementName < sortName then
				(
					sortName = ((re.GetRenderElement (i-1)).elementName)
					render_element = re.GetRenderElement (i-1)
				)
			)
		)
		re.RemoveRenderElement render_element
		return render_element
		
	)
	
	
	fn sortByName &re = 
	(
		
		local light_selects = #()
		local numberOfLightSelects = (GetNumberOfLightSelects re)
		
		local pos = "z_test"
		
		for i = 0 to (numberOfLightSelects-1) do
		(
			append light_selects (RemoveLowestLightSelect re)
		)
		
		for x in light_selects do
		(
			re.AddRenderElement x
		)
	)
	
	
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	--Main
	fn main = 
	(
		--Get Render Element Manager
		local re = maxOps.GetCurRenderElementMgr()
		
		--Holding the VRayLights
		local selectedLights = #()
		
		--Select Lights
		if lights.count > 0 then
		(
			SelectLights selectedLights
		)
		
		
		
		--Remove All Render Elements
		if clear_list.checked then
		(
			re.RemoveAllRenderElements()
		)
		
		--Remove all VRayLightSelects
		if remove_lightSelect.checked == true then
		(	
			removeAllLightSelects re
		)
		
		
		
		--Create VRayLightSelects
		if selectedLights.count > 0 then
		(
			GenerateLightSelects re selectedLights
		)
		else
		(
			messageBox "No lights in the Scene or no lights selected!"
		)
		
		if sort_elements.checked then
		(
			sortByName re			
		)
		
		free selectedLights		
	)
	
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	--//summary//
	--Updates the "AS 1"-Checkbox
	--(activate or deactivate "Instances as 1")
	--//summary//
	fn UpdateAsOne = 
	(
			if as_one.checked then
			(
					group_instances.enabled = false
			)
			else
			(
					group_instances.enabled = true
			)
	)
	
	
	--//summary//
	--Updates the "Pack"-Checkbox
	--(activate or deactivate "Instances as 1"
	-- and "AS 1")
	--//summary//
	fn UpdatePackSets =
	(
		if pack_sets.checked then
		(
			as_one.enabled = false
			group_instances.enabled = false
		)
		else
		(
			as_one.enabled = true
			if as_one.checked then
			(
				group_instances.enabled = false
			)
			else
			(
				group_instances.enabled = true
			)
		)
	)
	
	
	--//summary//
	--Updates the "Selection Set" -Drop down
	--for mode 3 and the Checkboxes for mode 5
	--//summary//
	fn UpdateLightSources = 
	(
		if btn_Apply.enabled == false then
		(
			 btn_Apply.enabled = true
		)
		
		--update drop down
		if light_sources.state == 3 then
		(
			if NamedSelectionSetManager.GetNumNamedSelSets() > 0 then
			(
				local selection_Set_Names = #()
				for i = 1 to NamedSelectionSetManager.GetNumNamedSelSets() do
				(
					
					local selSet_Name = NamedSelectionSetManager.GetNamedSelSetName (i-1)
					append selection_Set_Names selSet_Name
					selection_sets.enabled = true
				)	
				selection_sets.items = selection_Set_Names
			)
			else
			(
				btn_Apply.enabled = false
				messageBox "There are no selection sets."
			)
		)
		else
		(
			selection_sets.enabled = false
		)
		
		
		
		
		--update clickable "Pack" -Checkbox
		if light_sources.state == 5 then
		(
			pack_sets.enabled = true
			accept_duplicates.enabled = false
		)	
		else
		(
			pack_sets.enabled = false	
			accept_duplicates.enabled = true			
		)
		
		
		
		--update clickable checkboxes
		if pack_sets.enabled and pack_sets.checked then
		(
			as_one.enabled = false
			group_instances.enabled = false
		)
		else if pack_sets.enabled == false then
		(
			as_one.enabled = true
			if as_one.checked then
			(
				group_instances.enabled = false
			)	
			else
			(
				group_instances.enabled = true
			)
		)
	)
	
	--open help window
	fn OpenHelp = 
	(
		try(closerolloutfloater SubFloater)
		catch()
		SubFloater = NewRolloutFloater "Help" 380 500
		addRollout Menu02 SubFloater
		addRollout Menu03 SubFloater
	)
	
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	
	on btn_Apply pressed do main()
	on btn_RemoveAll pressed do removeAllLightSelects (maxOps.GetCurRenderElementMgr())
	on as_one changed state do UpdateAsOne()
	on pack_sets changed state do UpdatePackSets()
	on light_sources changed state do UpdateLightSources()
	on btn_help pressed do OpenHelp()
)


--help window
SubFloater
MainFloater = NewRolloutFloater "Render Elements" 260 565
addRollout Menu01 MainFloater
